/**
*	BreakGraph.java
*	p}gbNXɊÂՊE_̃Ot
*/

import	java.awt.*;
import	java.awt.event.*;
import	java.util.*;
import	java.text.DecimalFormat;

public class	BreakGraph	extends java.applet.Applet
{
	GraphCanvas	theCanvas;
	FuncPanel	functions;
	TextArea	message;

//	String	LN = System.getProperty( "line.separator" );	// sR[h
	String	LN = "\n";	// ̕m炵
	DecimalFormat	Form02 = new DecimalFormat( "0.00" );	// _Q\
	DecimalFormat	Form07 = new DecimalFormat( "0.0000000" );	// _V\
	
	static final int	FRAME_WIDTH  = 500;
	static final int	FRAME_HEIGHT = 480;
	static final int	GRAPH_WIDTH  = 400;
	static final int	GRAPH_HEIGHT = 320;
	
	/**
	*	
	*/
	public void	init()
	{
		// R|[lg̍쐬
		theCanvas = new GraphCanvas( GRAPH_WIDTH, GRAPH_HEIGHT );
		functions = new FuncPanel();
		message = new TextArea( "", 80, 10, 1);	// XN[o[t
		
		this.setLayout( null );
		this.add( theCanvas);
		this.add( message );
		this.add( functions );
		
		// R|[lg̈ʒu킹
		theCanvas.setBounds( 0, 0,  GRAPH_WIDTH, GRAPH_HEIGHT );
		message.setBounds( 0, GRAPH_HEIGHT, GRAPH_WIDTH, FRAME_HEIGHT-GRAPH_HEIGHT );
		functions.setBounds( GRAPH_WIDTH+8, 8, FRAME_WIDTH-GRAPH_WIDTH-16, FRAME_HEIGHT );

		// Ot͈͎̔w
		theCanvas.setRange( 0.0, 1.0, 0.0, 1.0 );
		
		// ɓ_łĂ݂
	//	theCanvas.plotPoint( 0.2, 0.3 );
		// ɐĂ݂
	//	theCanvas.drawLine( 0.3, 0.2, -0.1, 0.4 );
		//  X^2 `悵Ă݂
	//	plotFunc( new X2Func() );
	}
	
	/**
	*	֐̃vbg
	*	@param	`悵֐ւ̃C^[tFCX
	*/
	void	plotFunc( Func_Intf f_intf )
	{
		Vector	aFunc = new Vector();
		for( int i = 0; i <= 100; i++ )	// 100vbg
		{
			double	x = 0.01 * i;
			double	y = f_intf.func( x );
			
			double[]	p = new double[2];
			p[0] = (double)x;
			p[1] = (double)y;
			aFunc.addElement( p );
			
			printMessage( Form02.format(x) + " , " + Form07.format(y) + LN );	// ֐lo͂
		}
		theCanvas.drawPolyLine( aFunc );
	}
	
	/** bZ[W̕\ */
	void	printMessage( String str )
	{	message.append( str );
	}
	
	/** bZ[WNA */
	void	clearMessage()
	{	message.setText( "" );
	}
	
	/**
	*	nplFCi[NX
	*/
	class	FuncPanel	extends	Panel	implements ActionListener
	{
		Button	btn1 = new Button("Plot");
		Button	btn2 = new Button("Clear");
		TextField	txt = new TextField();
		
		/** Constractor */
		public	FuncPanel()
		{
			this.setLayout( new GridLayout(12, 2, 8, 8) );
			this.add( new Label("Matrix Size:") );
			this.add( txt );
			this.add( btn1 );	btn1.addActionListener( this );
			this.add( btn2 );	btn2.addActionListener( this );
			
			txt.setText( "5" );	// l
		}
		
		/** ANV̏ */
		public void actionPerformed( ActionEvent ev )
		{
			// Plot {^
			if( ev.getSource() == btn1 )
			{
				String	input = txt.getText();	// eLXgGAE
				int	m_size;
				try{
					m_size = Integer.parseInt( input );
				}
				catch ( NumberFormatException ex )
				{	printMessage( "Input Error: " + ex.getMessage() + LN );
					return;
				}
				// ՊE_̊֐vbg
				printMessage( "Plot [m_size = " + m_size + "] ----------------" + LN );
				BreakFunc	bFunc = new BreakFunc( m_size );
				plotFunc( bFunc );
				printMessage( "End ----------------" + LN + LN );
			}
			// Clear {^
			else if( ev.getSource() == btn2 )
			{
				theCanvas.clearAll();
				clearMessage();
			}
		}
	} // END FuncPanel
	
	/**
	*	main : for Standalone Application
	*/
	public static void	main( String args[] )
	{
		Frame	f = new Frame( "BreakGraph" );
		BreakGraph	self = new BreakGraph();
		
		f.setSize( FRAME_WIDTH, FRAME_HEIGHT );
		f.add( "Center", self );
		self.init();
		f.show();	// initɕ\Ɛ`悳

		// [x]{^ŕ鏈
		WindowListener	wl = new WindowAdapter()
		{
			public void windowClosing( WindowEvent ev )
			{	System.exit(0);
			}
		}; 
		f.addWindowListener( wl );
	}
}

/*--- End of File -----------------------------------------------------------*/
